﻿// BSLLS:CommonModuleNameClientServer-off - осмысленно, постфикс не имеет смысла
// Универсальные коллекции, вырезка из ом_Коллекция
//
// BSLLS:NestedFunctionInParameters-off - без лишних переменных выполнение быстрее
// BSLLS:EmptyRegion-off - пустые области разрешены

#Область ПрограммныйИнтерфейс

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

// Возвращает копию массива
//
// Параметры:  
// 	Массив - Массив - Исходный массив
// 	Начало - Число - Индекс начального элемента
// 	Количество - Число, Неопределено - Количество копируемых элементов
//
// Возвращаемое значение:
//   Массив
//
Функция МассивСкопировать(Массив, Начало = 0, Количество = Неопределено) Экспорт
	
	Размер	= Массив.Количество();
	Если Количество <> Неопределено И Количество - Начало > Размер Тогда
		ВызватьИсключение НСтр("ru = 'Размер копии массива превышает размер исходного массива! "
		+ "Обратитесь к разработчикам.'");
	КонецЕсли;
	
	Если Размер = 0 Тогда
		Результат	= Новый Массив;
	Иначе
		Результат	= Новый Массив(?(Количество = Неопределено
		, Размер - Начало
		, Мин(Количество, Размер)));
	КонецЕсли;
	Граница	= Результат.ВГраница();
	
	Для Индекс = 0 По Граница Цикл
		Результат[Индекс]	= Массив[Индекс + Начало];
	КонецЦикла;
	
	Возврат Результат;
	
КонецФункции // МассивСкопировать 

// Устанавливает значение свойства коллекции. Возвращает значение на момент до выполнения метода
//
// Параметры: 
// 	Коллекция - Структура - Коллекция значений
// 	Свойство - Строка - Имя свойства
// 	Значение - Произвольный - Новое значение
//
// Возвращаемое значение: 
// 	Произвольный
//
Функция СтруктураСвойство(Коллекция, Свойство, Значение = Null) Экспорт
	
	Результат	= Неопределено;
	Коллекция.Свойство(Свойство, Результат);
	
	Если Значение <> Null Тогда
		Коллекция.Вставить(Свойство, Значение);
	КонецЕсли;
	
	Возврат Результат;
	
КонецФункции // СтруктураСвойство 

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

#КонецОбласти

// BSLLS:NestedFunctionInParameters-on
// BSLLS:EmptyRegion-on
// BSLLS:CommonModuleNameClientServer-on
